#version 430 core

layout(location = 0) in vec3 vertex_position;
layout(location = 4) in vec4 position;

uniform mat4 particleMatrix;
uniform mat4 viewProjMatrix;
uniform float particleSize;
out float lifetime;

void main()
{
   vec4 position_viewspace = particleMatrix * vec4(position.xyz , 1);
   position_viewspace.xy += particleSize * (vertex_position.xy - vec2(0.5));
   gl_Position = viewProjMatrix * position_viewspace;
   lifetime = position.w;
};